
package dev.sonpx.loyalty.mcp.reward.enums;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import java.util.Arrays;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/**
 * Created by SonPhung on Wednesday, 13-Dec-2023
 */
@Getter
@RequiredArgsConstructor
public enum RoundingType {
    ROUND_UP("U"),
    ROUND_DOWN("D"),
    NEAREST("N");

    @JsonValue
    private final String code;

    @JsonCreator
    public static RoundingType fromCode(String code) {
        return Arrays.stream(values())
                .filter(e -> e.code.equalsIgnoreCase(code))
                .findFirst()
                .orElse(null);
    }
}
